## plast 2.3.1+dfsg

=== CMakeLists.txt ===
project(PlastLibrary)

################################################################################
# CMake required
################################################################################
cmake_minimum_required (VERSION 2.6)

find_package (JNI REQUIRED)

################################################################################
# PLAST release number
################################################################################
set (plast_VERSION_MAJOR 2)
set (plast_VERSION_MINOR 3)
set (plast_VERSION_PATCH 1)
set (plast-version ${plast_VERSION_MAJOR}.${plast_VERSION_MINOR}.${plast_VERSION_PATCH})
set (plast-date "xxxx-xx-xx")

################################################################################
# update date pattern with real value
################################################################################
INCLUDE(FindPerl)

# We execute a command that retrieves the current date.
IF (PERL_FOUND)
    EXECUTE_PROCESS (
        COMMAND "${PERL_EXECUTABLE}" "-le" "@T=localtime; printf (\"%04d-%02d-%02d %02d:%02d:%02d\",$T[5]+1900,$T[4]+1,$T[3],$T[2],$T[1],$T[0])"
        OUTPUT_VARIABLE plast-date
    )
ENDIF (PERL_FOUND)

################################################################################
# set files
################################################################################
set (LIBRARY_OUTPUT_PATH    lib/${CMAKE_BUILD_TYPE})
set (EXECUTABLE_OUTPUT_PATH bin/${CMAKE_BUILD_TYPE})
file (GLOB_RECURSE  PlastLibraryFiles  src/*)
file (GLOB_RECURSE  PlastCmdFiles      src/*)

################################################################################
# prepare targets
################################################################################
add_definitions       (-O3 -funroll-loops  -fomit-frame-pointer  -msse3)
include_directories   (${PROJECT_BINARY_DIR}/include  ${JAVA_INCLUDE_PATH} ${JAVA_INCLUDE_PATH2})
add_library           (PlastLibrary SHARED  ${PlastLibraryFiles} )
add_executable        (plast ${PlastCmdFiles})
target_link_libraries (plast pthread)

################################################################################
# OS specific stuffs
################################################################################
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    add_definitions(-D__DARWIN__)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    add_definitions(-D__LINUX__)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    add_definitions(-D__WINDOWS__)
    # IMPORTANT ! we have to add this flag for getting correct methods names in the library    
    # otherwise the Java JVM won't find the native JNI methods.
    set_target_properties (PlastLibrary PROPERTIES LINK_FLAGS -Wl,--kill-at)
    set_target_properties (PlastLibrary PROPERTIES PREFIX "")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

################################################################################
#  HEADERS COPY
################################################################################
file (COPY ${PROJECT_SOURCE_DIR}/src/
    DESTINATION ${PROJECT_BINARY_DIR}/include
    FILES_MATCHING PATTERN "*.hpp"  PATTERN "*.h"  PATTERN "*.pri"
)

install (DIRECTORY ${PROJECT_SOURCE_DIR}/src/ DESTINATION include FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h" PATTERN "*.pri")

################################################################################
#  CONFIGURATION FILE
################################################################################
configure_file (
    ${PROJECT_SOURCE_DIR}/src/misc/api/version.hpp.in 
    ${PROJECT_BINARY_DIR}/include/misc/api/version.hpp
)

## plast 2.3.1%2Bdfsg

=== debian/control ===
Source: plast
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libpcre3-dev,
               default-jdk
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/plast.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/plast.git
Homepage: https://plast.inria.fr/

Package: plast
Architecture: any-amd64 x32
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${java:Depends}
Description: Parallel Local Sequence Alignment Search Tool
 PLAST is a fast, accurate and NGS scalable bank-to-bank sequence
 similarity search tool providing significant accelerations of seeds-
 based heuristic comparison methods, such as the Blast suite of
 algorithms.
 .
 Relying on unique software architecture, PLAST takes full advantage of
 recent multi-core personal computers without requiring any additional
 hardware devices.

Package: plast-example
Architecture: all
Depends: ${misc:Depends}
Description: Parallel Local Sequence Alignment Search Tool (example data)
 PLAST is a fast, accurate and NGS scalable bank-to-bank sequence
 similarity search tool providing significant accelerations of seeds-
 based heuristic comparison methods, such as the Blast suite of
 algorithms.
 .
 Relying on unique software architecture, PLAST takes full advantage of
 recent multi-core personal computers without requiring any additional
 hardware devices.
 .
 This package contains some example data to test plast.

## plast 2.3.1+dfsg

=== debian/changelog ===
plast (2.3.1+dfsg-2) unstable; urgency=medium

  * Make sure wrapper script is calling bash
  * Restrict to architectures featuring SSE
    Closes: #814299
  * Fix spelling
  * Add Upstream-Contact

 -- Andreas Tille <tille@debian.org>  Wed, 10 Feb 2016 09:22:31 +0100

plast (2.3.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #814261)

 -- Andreas Tille <tille@debian.org>  Tue, 09 Feb 2016 10:20:36 +0100

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,9 @@
                cmake,
                libpcre3-dev,
                default-jdk
-Standards-Version: 3.9.8
+Standards-Version: 3.9.7
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/plast.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/plast.git
+Vcs-Git: https://anonscm.debian.org/debian-med/plast.git
 Homepage: https://plast.inria.fr/
 
 Package: plast

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

DEBPKGNAME := $(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
BUILD_DIR := obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ --buildsystem=cmake

override_dh_install:
	dh_install
	# install binary
	cp -a $(BUILD_DIR)/bin/*/plast debian/$(DEBPKGNAME)/usr/lib/$(DEBPKGNAME)/bin
	# no need for the includes
	rm -rf debian/*/usr/include

override_dh_auto_test:
	scripts/test-plast.sh

=== debian/watch ===
version=3

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://plast.inria.fr/developer-guide/ .*/files/plast_source_v(\d[\d.]+)\.tar\.gz

## plast 2.3.2%2Bdfsg

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

BUILD_DIR := obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export BDATE=$(shell TZ=UTC LC_ALL=C date -d"@$(SOURCE_DATE_EPOCH)" +'%Y-%m-%d')
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3

AMD64_SIMDE=sse3
I386_SIMDE=sse2 sse

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure-arch:
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	set -e ; for SIMD in $(AMD64_SIMDE) ; do \
		export CXXFLAGS="$(CXXFLAGS) -m$${SIMD}" && export CFLAGS="$(CFLAGS) -m$${SIMD}" && \
		dh_auto_configure --builddirectory=obj-$${SIMD} ; \
	done
ifeq (i386,$(DEB_HOST_ARCH))
	set -e ; for SIMD in $(I386_SIMDE) ; do \
		export CXXFLAGS="$(CXXFLAGS) -m$${SIMD}" && export CFLAGS="$(CFLAGS) -m$${SIMD}" && \
		dh_auto_configure --builddirectory=obj-$${SIMD} ; \
	done
endif
endif
	dh_auto_configure

override_dh_auto_build-arch:
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	set -e ; for SIMD in $(AMD64_SIMDE) ; do \
		dh_auto_build --builddirectory=obj-$${SIMD} ; \
	done
ifeq (i386,$(DEB_HOST_ARCH))
	set -e ; for SIMD in $(I386_SIMDE) ; do \
		dh_auto_build --builddirectory=obj-$${SIMD} ; \
	done
endif
endif
	dh_auto_build


override_dh_install-arch:
	dh_install -a
	# install binary
	cp -a $(BUILD_DIR)/bin/*/plast debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/bin/
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	set -e ; for SIMD in $(AMD64_SIMDE) ; do \
		cp -a obj-$${SIMD}/bin/*/plast debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/bin/plast-$${SIMD} ; \
	done
ifeq (i386,$(DEB_HOST_ARCH))
	set -e ; for SIMD in $(I386_SIMDE) ; do \
		cp -a obj-$${SIMD}/bin/*/plast debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/bin/plast-$${SIMD} ; \
	done
endif
endif
	# no need for the includes
	rm -rf debian/*/usr/include

override_dh_auto_configure-indep:
override_dh_auto_build-indep:
override_dh_auto_install-indep:
	echo "I: Nothing to do for arch:indep binary"

override_dh_gencontrol-arch:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

override_dh_auto_test-indep:
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
	set -e ; for SIMD in $(AMD64_SIMDE) ; do \
		if lscpu | grep -q $${SIMD} ; then \
		scripts/test-plast.sh obj-$${SIMD} ; fi ; \
	done
ifeq (i386,$(DEB_HOST_ARCH))
	set -e ; for SIMD in $(I386_SIMDE) ; do \
		if lscpu | grep -q $${SIMD} ; then \
		scripts/test-plast.sh obj-$${SIMD} ; fi ; \
	done
endif
endif
	scripts/test-plast.sh
endif

## plast 2.3.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 ################################################################################
 set (plast_VERSION_MAJOR 2)
 set (plast_VERSION_MINOR 3)
-set (plast_VERSION_PATCH 1)
+set (plast_VERSION_PATCH 2)
 set (plast-version ${plast_VERSION_MAJOR}.${plast_VERSION_MINOR}.${plast_VERSION_PATCH})
 set (plast-date "xxxx-xx-xx")

=== src/CMakeLists.txt ===
################################################################################
#  HEADERS COPY
################################################################################
file (COPY ${PROJECT_SOURCE_DIR}/src/
    DESTINATION ${PROJECT_BINARY_DIR}/include
    FILES_MATCHING PATTERN "*.hpp"  PATTERN "*.h"  PATTERN "*.pri"
)

install (DIRECTORY ${PROJECT_SOURCE_DIR}/src/ DESTINATION include FILES_MATCHING PATTERN "*.hpp" PATTERN "*.h" PATTERN "*.pri")

################################################################################
#  CONFIGURATION FILE
################################################################################
configure_file (
    ${PROJECT_SOURCE_DIR}/src/misc/api/version.hpp.in 
    ${PROJECT_BINARY_DIR}/include/misc/api/version.hpp
)

install (FILES ${PROJECT_BINARY_DIR}/include/misc/api/version.hpp DESTINATION include/os/api/)

################################################################################
#  LIBRARY GENERATION 
################################################################################

# We add the compilation options for the library
add_definitions (${plast-flags})

file (GLOB_RECURSE  LibraryFiles  ./*)

include_directories (${plast-includes}  ${JAVA_INCLUDE_PATH} ${JAVA_INCLUDE_PATH2})

add_library    (PlastLibrary-static  STATIC  ${LibraryFiles} )
#add_library    (PlastLibrary-dynamic SHARED  ${LibraryFiles} )

set_target_properties (PlastLibrary-static   PROPERTIES OUTPUT_NAME  PlastLibrary  clean_direct_output 1)
#set_target_properties (PlastLibrary-dynamic  PROPERTIES OUTPUT_NAME  PlastLibrary  clean_direct_output 1)


################################################################################
#  INSTALLATION 
################################################################################

# We install the libraries
install (TARGETS PlastLibrary-static DESTINATION lib)

=== debian/changelog ===
plast (2.3.2+dfsg-12) unstable; urgency=medium

  * Team upload.
  * cmake-4.patch: new: bump cmake minimum to 3.10. (Closes: #1113412)
  * d/rules: cleanup extra obj-* directories. (Closes: #1047303)
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/watch: convert to v5 Github template.
  * d/patches/*: normalise dep3 headers.

 -- Étienne Mollier <emollier@debian.org>  Sun, 12 Oct 2025 22:24:24 +0200

plast (2.3.2+dfsg-11) unstable; urgency=medium

  * Team Upload.
  * Add patch to fixup FTBFS with gcc-15 (Closes: #1097619)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 21 Sep 2025 00:37:18 +0530

plast (2.3.2+dfsg-10) unstable; urgency=medium

  * Fix watch file

 -- Andreas Tille <tille@debian.org>  Mon, 05 Dec 2022 18:19:37 +0100

plast (2.3.2+dfsg-9) unstable; urgency=medium

  * Team Upload.
  [ Andreas Tille ]
  * Disable link time optimization since it results in test suite failure
    Closes: #1015585
  * Standards-Version: 4.6.1 (routine-update)

 -- Nilesh Patra <nilesh@debian.org>  Wed, 20 Jul 2022 14:54:49 +0530

plast (2.3.2+dfsg-8) unstable; urgency=medium

  * Team Upload.
  * Drop d/p/use_debian_packaged_pcre.patch
  * Add pcre.patch to build with pcre2 (Closes: #999991)
  * d/control: B-D on libpcre2-dev instead of libpcre3-dev

 -- Nilesh Patra <nilesh@debian.org>  Mon, 24 Jan 2022 23:44:55 +0530

plast (2.3.2+dfsg-7) unstable; urgency=medium

  * Team upload.
  * debian/control: mark plast-example as Multi-Arch: foreign
  * debian/rules: build higher SIMD level binaries on amd64/i386
  * Do not parse d/changelog (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 31 Jan 2021 11:11:00 +0100

plast (2.3.2+dfsg-6) unstable; urgency=medium

  * Team Upload.
  * Search binary in obj-* dir to test across all arches
  * Test only on binary:any package
  * DEP3

 -- Nilesh Patra <npatra974@gmail.com>  Sun, 06 Dec 2020 15:13:01 +0530

plast (2.3.2+dfsg-5) unstable; urgency=medium

  * Team Upload.
  * Attempt enabling simde
  * Add Build-Dep and Built-Using since the license is AGPL
  * Enable simde flags
  * Do not hardcode the arch for running test

 -- Nilesh Patra <npatra974@gmail.com>  Sun, 06 Dec 2020 03:38:03 +0530

plast (2.3.2+dfsg-4) unstable; urgency=medium

  * Do nothing in dh_auto_configure and dh_auto_build for indep binaries
    Closes: #976525
  * Standards-Version: 4.5.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 21:55:04 +0100

plast (2.3.2+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Fix binary-all FTBFS (Closes: #974162)

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 12 Nov 2020 20:03:59 +0530

plast (2.3.2+dfsg-2) unstable; urgency=medium

  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Do not parse d/changelog (routine-update)
  * autopkgtest: s/ADTTMP/AUTOPKGTEST_TMP/g (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Tue, 10 Nov 2020 18:26:55 +0100

plast (2.3.2+dfsg-1) unstable; urgency=medium

  * Point watch file to github
  * New upstream version
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.5
  * Regard DEB_BUILD_OPTIONS in override_dh_auto_test
  * d/rules: Limit parsing d/changelog

 -- Andreas Tille <tille@debian.org>  Fri, 13 Jul 2018 19:20:45 +0200

plast (2.3.1+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Make build reproducible.
    - Use predictable strings for build date and OS.
  * Bump Standards-Version.
  * Enable full hardening.
  * Fix Vcs-Git.

 -- Sascha Steinbiss <sascha@steinbiss.name>  Sat, 28 May 2016 11:31:47 +0000

plast (2.3.1+dfsg-3) unstable; urgency=medium

  * Enable building arch all separately
    Closes: #816986

 -- Andreas Tille <tille@debian.org>  Sat, 19 Mar 2016 18:33:20 +0100

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,20 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 13),
                cmake,
-               libpcre3-dev,
-               default-jdk
-Standards-Version: 3.9.7
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/plast.git
-Vcs-Git: https://anonscm.debian.org/debian-med/plast.git
+               libpcre2-dev,
+               default-jdk,
+               libsimde-dev
+Standards-Version: 4.7.2
+Vcs-Browser: https://salsa.debian.org/med-team/plast
+Vcs-Git: https://salsa.debian.org/med-team/plast.git
 Homepage: https://plast.inria.fr/
 
 Package: plast
-Architecture: any-amd64 x32
+Architecture: any
+# Since the license of this package is AGPL, adding a Built-Using
+Built-Using: ${simde:Built-Using}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          ${java:Depends}
@@ -29,6 +32,7 @@
 
 Package: plast-example
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Parallel Local Sequence Alignment Search Tool (example data)
  PLAST is a fast, accurate and NGS scalable bank-to-bank sequence

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 BUILD_DIR := obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 export BDATE=$(shell TZ=UTC LC_ALL=C date -d"@$(SOURCE_DATE_EPOCH)" +'%Y-%m-%d')
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
 export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
 
@@ -15,6 +15,14 @@
 
 %:
 	dh $@ --buildsystem=cmake
+
+execute_after_dh_auto_clean:
+ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))
+	rm -rf $(foreach simd,$(AMD64_SIMDE),obj-$(simd)/)
+ifeq (i386,$(DEB_HOST_ARCH))
+	rm -rf $(foreach simd,$(I386_SIMDE),obj-$(simd)/)
+endif
+endif
 
 override_dh_auto_configure-arch:
 ifneq (,$(filter $(DEB_HOST_ARCH),amd64 i386))

=== debian/watch ===
Version: 5

Template: Github
Owner: PLAST-software
Project: plast-library
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/v@ANY_VERSION@
Dversionmangle: auto
Repacksuffix: +dfsg
